import 'dart:ui';

import 'package:flutter/material.dart';

class LoadingPainter extends CustomPainter {
  final Color color;
  LoadingPainter({
    required this.color,
  });

  @override
  void paint(Canvas canvas, Size size) {
    final paintGrey = Paint()
      ..strokeWidth = 5
      ..color = const Color(0xFFE6E6E6)
      ..style = PaintingStyle.fill;
    final paintWhileSmall = Paint()
      ..strokeWidth = 5
      ..color = Colors.white
      ..style = PaintingStyle.fill;
    final paintRed = Paint()
      ..strokeWidth = 5
      ..color = color
      ..style = PaintingStyle.fill;
    final paintWhileBig = Paint()
      ..strokeWidth = 10 * 0.6
      ..color = Colors.white
      ..style = PaintingStyle.stroke;
    double ratio = 0.6;

    canvas.drawCircle(const Offset(0, 0), 25 * ratio, paintGrey);
    canvas.drawRect(
        Rect.fromLTRB(-24 * ratio, -25 * ratio, 24 * ratio, -5 * ratio),
        paintRed);

    canvas.drawCircle(Offset(-21 * ratio, -5 * ratio), 3 * ratio, paintRed);
    canvas.drawCircle(Offset(21 * ratio, -5 * ratio), 3 * ratio, paintRed);
    canvas.drawCircle(const Offset(0, 0), 18 * ratio, paintWhileSmall);
    canvas.drawCircle(const Offset(0, 0), 30 * ratio, paintWhileBig);
  }

  @override
  bool shouldRepaint(covariant LoadingPainter oldDelegate) {
    return false;
  }
}
