import 'package:flutter/material.dart';

InputDecoration customInputDecoration({required String labelText}) {
  return InputDecoration(
    labelText: labelText,
    alignLabelWithHint: true,
    labelStyle: const TextStyle(fontSize: 16),
    border: OutlineInputBorder(
      borderRadius: BorderRadius.circular(13),
      borderSide: const BorderSide(color: Color(0xFFE2E2E2)),
    ),
  );
}

ButtonStyle customButtonStyle(
    {required Color color, required Color textColor}) {
  return ButtonStyle(
    elevation: MaterialStateProperty.all<double>(0),
    backgroundColor: MaterialStateProperty.resolveWith(
      (Set<MaterialState> states) {
        if (states.contains(MaterialState.disabled)) {
          return Colors.grey;
        } else if (states.contains(MaterialState.pressed)) {
          return Colors.red;
        } else {
          return color;
        }
      },
    ),
    foregroundColor: MaterialStateProperty.resolveWith(
      (Set<MaterialState> states) {
        if (states.contains(MaterialState.disabled)) {
          return Colors.white;
        } else {
          return textColor;
        }
      },
    ),
    shape: MaterialStateProperty.all<RoundedRectangleBorder>(
      RoundedRectangleBorder(
        borderRadius: BorderRadius.circular(13),
      ),
    ),
  );
}
