import 'package:bloc/bloc.dart';
import 'package:freezed_annotation/freezed_annotation.dart';
import 'package:image_picker/image_picker.dart';

part 'feedback_event.dart';
part 'feedback_state.dart';
part 'feedback_bloc.freezed.dart';

class FeedbackBloc extends Bloc<FeedbackEvent, FeedbackState> {
  FeedbackBloc() : super(const _Initial());
  @override
  Stream<FeedbackState> mapEventToState(
    FeedbackEvent event,
  ) =>
      event.when(
        started: _started,
        sending: _sending,
        fileSending: _fileSending,
      );

  Stream<FeedbackState> _started() async* {}

  Stream<FeedbackState> _sending(
    Map<String, dynamic> form,
  ) async* {
    yield const FeedbackState.initial();

    yield* state.maybeMap(
      initial: (initialState) async* {
        yield const FeedbackState.loading();

        try {
          await Future.delayed(const Duration(seconds: 4));
          yield const FeedbackState.success();
        } catch (e) {
          yield const FeedbackState.error();
        }
      },
      orElse: () => Stream.value(state),
    );
  }

  Stream<FeedbackState> _fileSending(List<XFile> images) async* {
    yield const FeedbackState.initial();

    yield* state.maybeMap(
      initial: (initialState) async* {
        yield const FeedbackState.fileSend();
        try {
          await Future.delayed(const Duration(seconds: 4));
          yield const FeedbackState.initial();
        } catch (e) {
          yield const FeedbackState.error();
        }
      },
      orElse: () => Stream.value(state),
    );
  }
}
